-- $Name: Клара - расхитительница варенья$
-- $Version: 1.4$

instead_version "1.9.0"
global { game_mode = false };
require "quotes"
require "para"
require "dash"
require "parser/metaparser"

input.cursor = img 'theme/cursor.gif'

parser.notitle = true

-- morph.debug = true
parser.cmd_history = true
parser.empty_warning = '?'
parser.hintinv = true
morph.yo = false
morph:init ('main.lua', 'game.lua')

me().person = 2
me().female = true
me().male = false
me().singular = true
parser.compass = true

parser.directions = { 
	{"n_to", "на", "север" };
	{"e_to", "на", "восток"};
	{"s_to", "на", "юг"};
	{"w_to", "на", "запад"};
	{"d_to", "вниз"};
	{"u_to", "наверх"};
	{"u_to", "вверх"};
}

parser.err_filter = false

parser.noway = function() p [[Туда тебе не пройти.]]; end

parser.unknown_verb = [[Непонятный какой-то глагол.]];

parser.unknown_obj = function(s, a, v)
	if v == "" then
		p ("Предложение не окончено.")
		return
	end
	p ("У тебя галлюцинации.")
	return
end;

help = cutscene {
	hideverbs = false;
	nam = 'Помощь';
	OnReturn = 'дальше';
	dsc = { [[Добро пожаловать! Вы играете в текстовую игру, в которой все взаимодействия 
		с окружающим миром осуществляются путем ввода команд. Такие игры также 
		известны как парсерные. Во время ввода текста игра будет подсказывать вам 
		что именно вы можете ввести, а если в нижней части экрана появляется знак 
		вопроса, то это означает, что игра не понимает введенную вами команду.^^
		Чтобы читать дальше, наберите на клавиатуре "дальше" и нажмите ввод.]],

		[[Например, если вы введете букву "о", то можете увидеть список всех действий, 
		которые начинаются на "о". Вам необязательно набирать все слово целиком -- 
		нажмите "TAB" или "пробел", и игра автоматически подставит подходящий вариант 
		в строку ввода. После этого вы увидите все объекты, над которым можно совершить 
		выбранное действие.^^Сейчас нажмите на клавишу "д" и затем -- "пробел".]],

		[[Чаще всего вы будете использовать команду "осмотреть" -- при этом вы получите описание
		ситуации. Также этой командой вы можете осматривать интересующие вас объекты и 
		персонажей.^^Удачного прохождения!^^
		P.S. Если вы хотите играть мышкой - выберите на стартовом экране: режим новичок.]];
	};
	walk_to = 'main';
}
main = room {
	hideverbs = false;
	cutscene_type = true;
	OnReturn = 'как играть';
	nam = '<c>КЛАРА - РАСХИТИТЕЛЬНИЦА ВАРЕНЬЯ</c>';
	dsc = function(s)
		pn (txtb[[Версия: ]], "1.4")
		pn (txtb[[Оригинальная игра для платформы "6 days": ]], [[Жариков Николай]])
		pn (txtb[[Ремейк на INSTEAD: ]], [[Петр Косых]])
		pn (txtb[[Рисунки: ]], [[Максим Ганенко]])
		pn (txtb[[Тестирование: ]], [[j-maks, im-kerber]])
		pn (txtb[[Музыка: ]], [[http://freemusicarchive.org]])
		pn (txtb[[Движок: ]], [[http://instead.syscall.ru]])
		pn ()
		pn (txtr [[2006 -- 2015 г.]])
	end;
	Help = function(s)
		walk 'help'
	end;
	Next = function(s)
		walk 'intro'
	end;
	Mode = function(s)
		parser.hideverbs = not parser.hideverbs
		game_mode = parser.hideverbs
	end;
	verbs = {
		{ "Help", "как играть" },
		{ "Next", "начать" },
		{ "Mode", "режим", function(s)
			if parser.hideverbs then
				return "новичок"
			else
				return "эксперт"
			end
		end },
	};
}

intro = cutscene {
	nam = 'Пролог';
	hideverbs = false;
	OnReturn = 'дальше';
	dsc = {[[Ты маленькая девочка Клара, которая очень любит сладости и которые злостные родители прячут от тебя всеми возможными способами. Не далее как вчера ты обнаружила, что они спрятали от тебя большую банку варенья в серванте на кухне. Будучи наблюдательным ребенком ты заметила, что дверцы серванта запираются на ключ, а ключ мама забирает с собой в спальню.^
		Замыслив коварный план похищения варенья ты осчастливила родителей ранним уходом ко сну, но на деле ты не спала - ты расчетливо дождалась пока уснут они.^
		В доме воцарилась тишина. Ты лежишь в постели, свет ночной лампы проникает в комнату через приоткрытую дверь. Час пробил!]]
	};
	left = function(s)
		set_music 'mus/theme.ogg'
	end;
	walk_to = 'krovat';
}

game.verbs = {};

parser.verb.Inventory()
parser.verb.Exam()
parser.verb.LookAt()
parser.verb.Search()
parser.verb.Open()
parser.verb.Close()
parser.verb.Push()
parser.verb.Pull()
parser.verb.Smell()
parser.verb.Eat()
parser.verb.Put()
parser.verb.Attack()
parser.verb.Take()
parser.verb.Drop()
parser.verb.Remove()
parser.verb.Wait()
parser.verb.Read()
parser.verb.Tie()
parser.verb.TalkTo()
parser.verb.Give()
parser.verb.Walk()

me().Exam = function(s)
	return parser.events.Inventory(parser)
end

dofile 'game.lua'
game.pic = function(s)
	if here() == main or here() == intro or here() == help then
		return 'gfx/bed0.png'
	elseif here() == krovat then
		return 'gfx/bed1.png'
	elseif here() == bedroom then
		return 'gfx/bed2.png'
	elseif here() == koridor then
		if up then
			return 'gfx/koridor2.png'
		else
			return 'gfx/koridor0.png'
		end
	elseif here() == kitchen then
		return 'gfx/kitchen0.png'
	elseif here() == bedroom_rod then
		return 'gfx/bedroom0.png'
	elseif here() == happyend then
		return 'gfx/banka.png'
	end
end;
parser.events.after_Any = function(s)
	if player_moved() and not here().nocls then
		if not restore_mode then
			parser:cls()
		end
	end
	restore_mode = false
end

game.action = stead.hook(game.action, function (f, s, cmd, ...)
	if cmd == 'parser_edit' or cmd == 'parser_enter' then
		set_sound ('key'..rnd(3)..'.ogg')
	end
	return f(s, cmd, ...)
end)

game.fading = function()
	local p = stead.call(game, 'pic')
	if p ~= last_pic then
		last_pic = p
		return 6
	end
	if player_moved() and not here().nocls then
		return 6
	end
end

function init()
	if PLATFORM == 'ANDROID' or PLATFORM == 'IOS' or PLATFORM == 'S60'
		or PLATFORM == 'WINCE' then
		game_mode = false
	else
		game_mode = true
	end
end

function start()
	parser.hideverbs = game_mode
end

parser.verb._Service()
